<template>
  <ob-form
    :form-data="formData"
    :is-show-controls="isShowControls"
    @submit="onSubmitHandler"
    :is-active-element="formData.isActive"
    :dropdown-menu="dropdownMenu"
    @change-active="onChangeActive"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          v-model="formData.title"
          label="Наименование"
          placeholder="Введите наименование"
          :disabled="formData.isActive"
        />
      </div>
    </div>

    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          v-model="formData.description"
          label="Описание"
          placeholder="Введите текст"
          :disabled="formData.isActive"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
  import cloneDeep  from 'clone-deep';
  import ObForm     from 'common-components/src/obComponents/obForm';
  import ObInput    from 'common-components/src/obComponents/obInput';
  import ObTextarea from 'common-components/src/obComponents/obTextarea';

  export default {
    props: {
      dataSource: {
          type: Object,
          default: () => {
            return {
              title: '',
              description: '',
              isActive: false
            }
          }
      },
      activites: {
          type: Array,
          required: true,
          default: () => []
      },
      isShowControls:{
          type: Boolean,
          default: true
      },
    },

    components: {
      ObForm,
      ObInput,
      ObTextarea,
    },

    data() {
      return {
        formData: {}
      }
    },

    watch: {
      dataSource: {
        handler(newVal) {
          this.formData = { ...newVal }
        },
        deep: true,
        immediate: true
      }
    },

    computed: {
      isNew () {
        return !this.formData.uuid;
      },
      dropdownMenu () {
        return (this.isNew || this.dataSource.deleted_at) ? null : [
          {
            title: 'Удалить',
            className: 'color-error',
            method: () => {
              this.$emit('delete');
            }
          }
        ]
      }
    },

    methods: {
      onSubmitHandler () {
        const data = cloneDeep(this.formData);
        this.$emit('submit', data)
      },

      onChangeActive() {
        this.formData.isActive = !this.formData.isActive
      },
    }
  }
</script>

<style lang="scss" scoped>
  ::v-deep {
    .ob-menu-dropdown-container .menu-dropdown-list__item button .col-right__title {
      color: $color-error !important;
    }
  }
</style>